# Generated by go2rpm 1.3
%bcond_without check

# https://github.com/helm/helm
%global goipath         helm.sh/helm/v3
%global forgeurl        https://github.com/helm/helm
Version:                3.5.4

%gometa

%global common_description %{expand:
Helm is a tool for managing Charts. Charts are packages of pre-configured
Kubernetes resources.

Use Helm to:
- Find and use popular software packaged as Helm Charts to run in Kubernetes
- Share your own applications as Helm Charts
- Create reproducible builds of your Kubernetes applications
- Intelligently manage your Kubernetes manifest files
- Manage releases of Helm packages}

%global golicenses      LICENSE
%global godocs          ADOPTERS.md SECURITY.md code-of-conduct.md\\\
                        CONTRIBUTING.md README.md

Name:           %{goname}
Release:        2%{?dist}
Summary:        The Kubernetes Package Manager

# Upstream license specification: Apache-2.0
License:        ASL 2.0
URL:            %{gourl}
Source0:        %{gosource}
# update test expectation for new template error string
Patch0:         %{url}/commit/f57c01cd9365d7f50a7e3d69b8c75a687392e74c.patch
# Partial revert of k8s 1.19 support, drop when k8s api packages are updated
# https://github.com/helm/helm/commit/b7c38c879a91cabec02699be1c4070206f84c88e
Patch1:         helm-3-missing-args.patch

BuildRequires:  golang(github.com/asaskevich/govalidator)
BuildRequires:  golang(github.com/BurntSushi/toml)
BuildRequires:  golang(github.com/containerd/containerd/content)
BuildRequires:  golang(github.com/containerd/containerd/errdefs)
BuildRequires:  golang(github.com/containerd/containerd/remotes)
BuildRequires:  golang(github.com/cyphar/filepath-securejoin)
BuildRequires:  golang(github.com/deislabs/oras/pkg/auth)
BuildRequires:  golang(github.com/deislabs/oras/pkg/auth/docker)
BuildRequires:  golang(github.com/deislabs/oras/pkg/content)
BuildRequires:  golang(github.com/deislabs/oras/pkg/context)
BuildRequires:  golang(github.com/deislabs/oras/pkg/oras)
BuildRequires:  golang(github.com/docker/distribution/configuration)
BuildRequires:  golang(github.com/docker/distribution/registry)
BuildRequires:  golang(github.com/docker/distribution/registry/auth/htpasswd)
BuildRequires:  golang(github.com/docker/distribution/registry/storage/driver/inmemory)
BuildRequires:  golang(github.com/docker/docker/pkg/term)
BuildRequires:  golang(github.com/docker/go-units)
BuildRequires:  golang(github.com/evanphx/json-patch)
BuildRequires:  golang(github.com/gobwas/glob)
BuildRequires:  golang(github.com/gofrs/flock)
BuildRequires:  golang(github.com/gosuri/uitable)
BuildRequires:  golang(github.com/jmoiron/sqlx)
BuildRequires:  golang(github.com/lib/pq)
BuildRequires:  golang(github.com/Masterminds/semver/v3)
BuildRequires:  golang(github.com/Masterminds/sprig/v3)
BuildRequires:  golang(github.com/Masterminds/squirrel)
BuildRequires:  golang(github.com/Masterminds/vcs)
BuildRequires:  golang(github.com/mitchellh/copystructure)
BuildRequires:  golang(github.com/opencontainers/go-digest)
BuildRequires:  golang(github.com/opencontainers/image-spec/specs-go)
BuildRequires:  golang(github.com/opencontainers/image-spec/specs-go/v1)
BuildRequires:  golang(github.com/phayes/freeport)
BuildRequires:  golang(github.com/pkg/errors)
BuildRequires:  golang(github.com/rubenv/sql-migrate)
BuildRequires:  golang(github.com/sirupsen/logrus)
BuildRequires:  golang(github.com/spf13/cobra)
BuildRequires:  golang(github.com/spf13/cobra/doc)
BuildRequires:  golang(github.com/spf13/pflag)
BuildRequires:  golang(github.com/xeipuuv/gojsonschema)
BuildRequires:  golang(golang.org/x/crypto/bcrypt)
BuildRequires:  golang(golang.org/x/crypto/openpgp)
BuildRequires:  golang(golang.org/x/crypto/openpgp/clearsign)
BuildRequires:  golang(golang.org/x/crypto/openpgp/packet)
BuildRequires:  golang(golang.org/x/term)
BuildRequires:  golang(k8s.io/api/apps/v1)
BuildRequires:  golang(k8s.io/api/apps/v1beta1)
BuildRequires:  golang(k8s.io/api/apps/v1beta2)
BuildRequires:  golang(k8s.io/api/batch/v1)
BuildRequires:  golang(k8s.io/api/core/v1)
BuildRequires:  golang(k8s.io/api/extensions/v1beta1)
BuildRequires:  golang(k8s.io/apiextensions-apiserver/pkg/apis/apiextensions/v1)
BuildRequires:  golang(k8s.io/apiextensions-apiserver/pkg/apis/apiextensions/v1beta1)
BuildRequires:  golang(k8s.io/apimachinery/pkg/api/equality)
BuildRequires:  golang(k8s.io/apimachinery/pkg/api/errors)
BuildRequires:  golang(k8s.io/apimachinery/pkg/api/meta)
BuildRequires:  golang(k8s.io/apimachinery/pkg/api/validation)
BuildRequires:  golang(k8s.io/apimachinery/pkg/api/validation/path)
BuildRequires:  golang(k8s.io/apimachinery/pkg/apis/meta/v1)
BuildRequires:  golang(k8s.io/apimachinery/pkg/apis/meta/v1/unstructured)
BuildRequires:  golang(k8s.io/apimachinery/pkg/fields)
BuildRequires:  golang(k8s.io/apimachinery/pkg/labels)
BuildRequires:  golang(k8s.io/apimachinery/pkg/runtime)
BuildRequires:  golang(k8s.io/apimachinery/pkg/runtime/schema)
BuildRequires:  golang(k8s.io/apimachinery/pkg/types)
BuildRequires:  golang(k8s.io/apimachinery/pkg/util/intstr)
BuildRequires:  golang(k8s.io/apimachinery/pkg/util/strategicpatch)
BuildRequires:  golang(k8s.io/apimachinery/pkg/util/validation)
BuildRequires:  golang(k8s.io/apimachinery/pkg/util/validation/field)
BuildRequires:  golang(k8s.io/apimachinery/pkg/util/wait)
BuildRequires:  golang(k8s.io/apimachinery/pkg/util/yaml)
BuildRequires:  golang(k8s.io/apimachinery/pkg/watch)
BuildRequires:  golang(k8s.io/apiserver/pkg/endpoints/deprecation)
BuildRequires:  golang(k8s.io/cli-runtime/pkg/genericclioptions)
BuildRequires:  golang(k8s.io/cli-runtime/pkg/printers)
BuildRequires:  golang(k8s.io/cli-runtime/pkg/resource)
BuildRequires:  golang(k8s.io/client-go/discovery)
BuildRequires:  golang(k8s.io/client-go/dynamic)
BuildRequires:  golang(k8s.io/client-go/kubernetes)
BuildRequires:  golang(k8s.io/client-go/kubernetes/scheme)
BuildRequires:  golang(k8s.io/client-go/kubernetes/typed/apps/v1)
BuildRequires:  golang(k8s.io/client-go/kubernetes/typed/core/v1)
BuildRequires:  golang(k8s.io/client-go/plugin/pkg/client/auth)
BuildRequires:  golang(k8s.io/client-go/rest)
BuildRequires:  golang(k8s.io/client-go/tools/cache)
BuildRequires:  golang(k8s.io/client-go/tools/clientcmd)
BuildRequires:  golang(k8s.io/client-go/tools/watch)
BuildRequires:  golang(k8s.io/client-go/util/homedir)
BuildRequires:  golang(k8s.io/klog/v2)
BuildRequires:  golang(k8s.io/kubectl/pkg/cmd/util)
BuildRequires:  golang(k8s.io/kubectl/pkg/validation)
BuildRequires:  golang(sigs.k8s.io/yaml)

%if %{with check}
# Tests
BuildRequires:  golang(github.com/DATA-DOG/go-sqlmock)
BuildRequires:  golang(github.com/mattn/go-shellwords)
BuildRequires:  golang(github.com/stretchr/testify/assert)
BuildRequires:  golang(github.com/stretchr/testify/require)
BuildRequires:  golang(github.com/stretchr/testify/suite)
BuildRequires:  golang(golang.org/x/crypto/openpgp/errors)
BuildRequires:  golang(k8s.io/client-go/kubernetes/fake)
BuildRequires:  golang(k8s.io/client-go/rest/fake)
BuildRequires:  golang(k8s.io/kubectl/pkg/cmd/testing)
%endif

# Cannot build for s390x due to missing golang-github-rubenv-sql-migrate
# https://bugzilla.redhat.com/show_bug.cgi?id=1971029
ExcludeArch:    s390x

%description
%{common_description}

%package -n     helm
Summary:        %{summary}
%description -n helm
%{common_description}

%gopkg

%prep
%goprep
%autopatch -p1

%build
for cmd in cmd/* ; do
  %gobuild -o %{gobuilddir}/bin/$(basename $cmd) %{goipath}/$cmd
done

%install
%gopkginstall
install -m 0755 -vd                     %{buildroot}%{_bindir}
install -m 0755 -vp %{gobuilddir}/bin/* %{buildroot}%{_bindir}/

%if %{with check}
%check
# FAIL: TestValidateNoDeprecations
rm pkg/lint/rules/deprecations_test.go
# FAIL: TestDeprecatedAPIFails
rm pkg/lint/rules/template_test.go
# Needs Internet access
rm pkg/plugin/installer/vcs_installer_test.go
%ifarch i686 armv7hl
# FAIL: TestPlatformPrepareCommand
# https://bugzilla.redhat.com/show_bug.cgi?id=1971091
rm pkg/plugin/plugin_test.go
%endif
%gocheck
%endif

%files -n helm
%license LICENSE
%doc ADOPTERS.md SECURITY.md code-of-conduct.md CONTRIBUTING.md README.md
%{_bindir}/*

%gopkgfiles

%changelog
* Thu Jul 22 2021 Fedora Release Engineering <releng@fedoraproject.org> - 3.5.4-2
- Rebuilt for https://fedoraproject.org/wiki/Fedora_35_Mass_Rebuild

* Sat May 22 20:47:07 PDT 2021 Davide Cavalca <davide@cavalca.name> - 3.5.4-1
- Initial package

